/*----------------------------------------------------------------------------
/ [vobNAAD͌								2005 (C)LogicPack
/	05.07.29									000		M.Yamada
/		first release
/---------------------------------------------------------------------------*/
#include <stdio.h>
#include "iodefine.h"
#include "m801l.h"
#include "sci.h"
#include "debug.h"
#include "mstring.h"

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
#define user_break()	(sci1_get() == (0x100 | 0x1b))		/* ESC */

typedef struct{
	volatile byte *dir;			/* fBNVWX^ւ̃|C^ */
	byte init;					/* l */
	byte test;					/* pݒl */
}DIR_INFO;

typedef struct{
	volatile byte *port;		/* |[gւ̃|C^ */
//	byte mask;					/* Ώۃ}XN */
}OUT_INFO;

typedef struct{
	volatile byte *port;		/* |[gւ̃|C^ */
	byte mask;					/* Ώۃ}XN */
	const char *str;
}IN_INFO;

typedef struct{
	OUT_INFO	*out;			/* o̓|[g */
	byte		obit;			/* o̓rbg */
	IN_INFO		*in;			/* ̓|[g */
	byte		ibit;			/* ̓rbg */
	const char	*ostr;
}TEST_DATA;

#define DIR_MAX	7
#define OUT_MAX	4
enum{ OUT_P6, OUT_P8, OUT_P9, OUT_PB };
#define IN_MAX	5
enum{ IN_P1, IN_P5, IN_P6, IN_P8, IN_PA };

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
/* fBNVe[u */
const DIR_INFO dir_tbl[DIR_MAX] = {
	{ (volatile byte*)&P1DDR, 0xff, 0xfe },
	{ (volatile byte*)&P5DDR, 0xf3, 0xf3 },
	{ (volatile byte*)&P6DDR, 0x80, 0x87 },
	{ (volatile byte*)&P8DDR, 0xec, 0xed },
	{ (volatile byte*)&P9DDR, 0xc0, 0xd5 },
	{ (volatile byte*)&PADDR, 0x00, 0x00 },
	{ (volatile byte*)&PBDDR, 0xff, 0xff }
};

/* o̓|[ge[u */
const OUT_INFO out_tbl[OUT_MAX] = {
	{ (volatile byte*)&P6DR },
	{ (volatile byte*)&P8DR },
	{ (volatile byte*)&P9DR },
	{ (volatile byte*)&PBDR }
};

/* ̓|[ge[u */
const IN_INFO in_tbl[IN_MAX] = {
	{ (volatile byte*)&P1DR, 0x01, "P1" },
	{ (volatile byte*)&P5DR, 0x0c, "P5" },
	{ (volatile byte*)&P6DR, 0x80, "P6" },
	{ (volatile byte*)&P8DR, 0x12, "P8" },
	{ (volatile byte*)&PADR, 0xff, "PA" }
};

/* e[u */
const TEST_DATA test_tbl[] = {
	{ &out_tbl[OUT_P6], 0x01, &in_tbl[IN_P5], 0x04, "P60 H" },
	{ &out_tbl[OUT_P6], 0x02, &in_tbl[IN_P8], 0x02, "P61 H" },
	{ &out_tbl[OUT_P6], 0x04, &in_tbl[IN_P8], 0x10, "P62 H" },
	{ &out_tbl[OUT_P8], 0x01, &in_tbl[IN_P1], 0x01, "P80 H" },
	{ &out_tbl[OUT_P9], 0x01, &in_tbl[IN_P6], 0x80, "P90 H" },
	{ &out_tbl[OUT_P9], 0x04, &in_tbl[IN_P5], 0x08, "P92 H" },
	{ &out_tbl[OUT_P9], 0x10, &in_tbl[IN_P5], 0x04, "P94 H" },
	{ &out_tbl[OUT_PB], 0x01, &in_tbl[IN_PA], 0x01, "PB0 H" },
	{ &out_tbl[OUT_PB], 0x02, &in_tbl[IN_PA], 0x02, "PB1 H" },
	{ &out_tbl[OUT_PB], 0x04, &in_tbl[IN_PA], 0x04, "PB2 H" },
	{ &out_tbl[OUT_PB], 0x08, &in_tbl[IN_PA], 0x08, "PB3 H" },
	{ &out_tbl[OUT_PB], 0x10, &in_tbl[IN_PA], 0x10, "PB4 H" },
	{ &out_tbl[OUT_PB], 0x20, &in_tbl[IN_PA], 0x20, "PB5 H" },
	{ &out_tbl[OUT_PB], 0x40, &in_tbl[IN_PA], 0x40, "PB6 H" },
	{ &out_tbl[OUT_PB], 0x80, &in_tbl[IN_PA], 0x80, "PB7 H" },
	{ NULL,				0,	  NULL, 		  0, NULL }
};

static int loopback(void);
static int adcheck(void);

static void get_indata(byte *indata);
static void disp(const char *ostr, const byte *indata, bool err);
static bool adjudge(int ch, volatile word *addr, word min, word max);

/*-------------------------------------------------------------------
/ [vobN
/------------------------------------------------------------------*/
void test_loopback(void)
{
	byte irq5;
	TEST_DATA *testp;
	int i;
	int ecnt = 0;
	int err;
	/*----- Jn --------------------------*/
	irq5 = INTC.IER.BIT.IRQ5E;
	if( irq5 ){ INTC.IER.BIT.IRQ5E = 0; }
	BSC.BCR.BIT.WAITE = 0;

	/* AD  */
	ITU.TISRA.BIT.IMIEA0 = 0;	/* Timer荞ݒ~ */
	AD.ADCSR.BIT.ADIE = 0;		/* AD荞ݒ~ */
	AD.ADCSR.BIT.ADST = 0;		/* AD~ */
	AD.ADCSR.BIT.ADF = 0;		/* Ô߃tONA */
	AD.ADCSR.BIT.SCAN = 1;
	/* pfBNVݒ */
	for( i = 0; i < DIR_MAX; i++ ){
		*dir_tbl[i].dir = dir_tbl[i].test;
	}

	debug_out("\r\n*IO loopback check\r\n");
	err = loopback();
	if( err != -1 ){
		ecnt += err;
		debug_out("\r\n*P70..77 AD input check\r\n");
		err = adcheck();
		if( err != -1 ){
			ecnt += err;
		}
	}
	/* S̔ */
#if 0
	if( ecnt == 0 ){
		debug_out("\r\nALL OK\r\n\r\n");
	}else{
		debug_out("\r\nNG\r\n\r\n");
	}
#else
	debug_out("\r\n");
#endif
	/*----- I --------------------------*/
	/* fBNVɖ߂ */
	for( i = 0; i < DIR_MAX; i++ ){ 
		*dir_tbl[i].dir = dir_tbl[i].init;
	}
	if( cpu_type == CPU_M801 ){ BSC.BCR.BIT.WAITE = 1; }
	if( irq5 ){ INTC.IER.BIT.IRQ5E = 1; }
	/* AD  */
	AD.ADCSR.BIT.SCAN = 0;		/* non scan */
	AD.ADCSR.BIT.CKS  = 0;
	AD.ADCSR.BIT.CH   = 0;		/* ch0 */
	AD.ADCSR.BIT.ADIE = 1;		/* Jn */
	ITU.TISRA.BIT.IMIEA0 = 1;
}

/*---------------------------------------------------------
/ [vobN
/	RET:
/	  -1̎user break
/--------------------------------------------------------*/
static int loopback(void)
{
	bool err = FALSE;
	TEST_DATA *testp;
	int i;
	int ecnt = 0;
	static byte indata[IN_MAX];

	/* SrbgNA */
	for( i = 0; i < OUT_MAX; i++ ){
		*out_tbl[i].port = 0x00;
	}
	get_indata(indata);
	for( i = 0; i < IN_MAX; i++ ){
		if( indata[i] != 0x00 ){
			err = TRUE;
			ecnt++;
		}
	}
	disp("ALL 0", indata, err);
	/* ʃ`FbN */
	for( testp = test_tbl; testp->out != NULL; testp++ ){
		err = FALSE;
		*(testp->out->port) = testp->obit;
		get_indata(indata);
		for( i = 0; i < IN_MAX; i++ ){
			if( testp->in->port == in_tbl[i].port ){
				if( indata[i] != testp->ibit ){
					err = TRUE;
					ecnt++;
				}
			}else{
				if( indata[i] != 0x00 ){
					err = TRUE;
					ecnt++;
				}
			}
		}
		*(testp->out->port) = 0x00;
		disp(testp->ostr, indata, err);
		if( user_break() ){
			ecnt = -1;
			break;
		}
	}
	return ecnt;
}

/*---------------------------------------------------------
/ AD
/	RET:
/	  -1̎user break
/--------------------------------------------------------*/
static int adcheck(void)
{
	#define AD_RANGE	52
	#define AD0_JUDGE	(1023 * 8 / 9)
	#define AD1_JUDGE	(1023 * 7 / 9)
	#define AD2_JUDGE	(1023 * 6 / 9)
	#define AD3_JUDGE	(1023 * 5 / 9)
	#define AD4_JUDGE	(1023 * 4 / 9)
	#define AD5_JUDGE	(1023 * 3 / 9)
	#define AD6_JUDGE	(1023 * 2 / 9)
	#define AD7_JUDGE	(1023 * 1 / 9)
	int ecnt = 0;

	AD.ADCSR.BIT.CH   = 3;		/* ch0`3 */
	AD.ADCSR.BIT.ADST = 1;
	while( !AD.ADCSR.BIT.ADF ){
		if( user_break() ){
			ecnt = -1;
			break;
		}
	}
	AD.ADCSR.BIT.ADF = 0;
	AD.ADCSR.BIT.ADST = 0;
	if( ecnt == -1 ){ return ecnt; }

	if( !adjudge(0, &AD.ADDRA, AD0_JUDGE - AD_RANGE, AD0_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(1, &AD.ADDRB, AD1_JUDGE - AD_RANGE, AD1_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(2, &AD.ADDRC, AD2_JUDGE - AD_RANGE, AD2_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(3, &AD.ADDRD, AD3_JUDGE - AD_RANGE, AD3_JUDGE + AD_RANGE) ){ ecnt++; }

	AD.ADCSR.BIT.CH   = 7;		/* ch4`7 */
	AD.ADCSR.BIT.ADST = 1;
	while( !AD.ADCSR.BIT.ADF ){
		if( user_break() ){
			ecnt = -1;
			break;
		}
	}
	AD.ADCSR.BIT.ADF = 0;
	AD.ADCSR.BIT.ADST = 0;
	if( ecnt == -1 ){ return ecnt; }

	if( !adjudge(4, &AD.ADDRA, AD4_JUDGE - AD_RANGE, AD4_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(5, &AD.ADDRB, AD5_JUDGE - AD_RANGE, AD5_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(6, &AD.ADDRC, AD6_JUDGE - AD_RANGE, AD6_JUDGE + AD_RANGE) ){ ecnt++; }
	if( !adjudge(7, &AD.ADDRD, AD7_JUDGE - AD_RANGE, AD7_JUDGE + AD_RANGE) ){ ecnt++; }

	return ecnt;
}

/*--- ͒l擾 ---*/
static void get_indata(byte *indata)
{
	int i;
	for( i = 0; i < IN_MAX; i++,indata++ ){
		*indata = *in_tbl[i].port & in_tbl[i].mask;
	}
}

/*--- \ ---*/
static void disp(const char *ostr, const byte *indata, bool err)
{
	static char buf[3];
	int i;
	debug_out("out ");
	debug_out(ostr);
	debug_out(" -> in ");
	for( i = 0; i < IN_MAX; i++ ){
		debug_out(in_tbl[i].str);
		debug_out(":");
		byte2str(indata[i], buf);
		debug_out(buf);
		debug_out(" ");
	}
	if( !err ){	debug_out("OK\r\n"); }
	else{		debug_out("NG\r\n"); }
}

/*--- ADƕ\ ---*/
static bool adjudge(int ch, volatile word *addr, word min, word max)
{
	static char buf[5];
	bool err = FALSE;
	word ad;
	ad = *addr >> 6;
	if( ad < min || ad > max ){ err = TRUE; }
	debug_out("AD");
	utoa(ch, buf);		debug_out(buf);
	debug_out(" in ");
	word2str(min, buf);	debug_out(buf);
	debug_out("-");
	word2str(max, buf);	debug_out(buf);
	debug_out(" -> ");
	word2str(ad, buf);	debug_out(buf);
	if( !err ){
		debug_out(" OK\r\n");
	}else{
		debug_out(" NG\r\n");
	}

	return !err;
}
