/*----------------------------------------------------------------------------
/ l|WOP@k								2004 (C)LogicPack
/	2004.12.23				V1.00						M.Yamada
/	2005.08.19									001		M.Yamada
/		M800LpɑSʕύX
/---------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "iodefine.h"
#include "sci.h"
#include "ad.h"
#include "m801l.h"
#include "dhcp.h"
#include "lan.h"
#include "command.h"
#include "mstring.h"
#include "debug.h"
#include "usbn9604.h"
#include "ltest.h"

#ifdef __cplusplus
extern "C" {
#endif
void abort(void);
#ifdef __cplusplus
}
#endif

/*-----------------------------------------------
/ *GLOBAL
/----------------------------------------------*/
#pragma section SYS
volatile dword user_program_addr;
volatile bool  user_program_flag;
#pragma section
volatile long	tim1ms;						/* ėp^C}JE^(msec) */
word ad_data;								/* ŐVADl(MSB=1->update */

const char m801l_version[]="1.00";
//const char m801l_version[]="0.90";

int cpu_type;

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
//#pragma section LAN
static byte tmp[256];
//#pragma section

/* message string */
const char cpu[] = "M-800 Loader";

#if !defined(RAM_EMULATE)
  const char prompt_m800[] = "m800l>";
  const char prompt_m801[] = "m801l>";
  const char prompt_m802[] = "m802l>";
#else
  const char prompt_m800[] = "m800l(r)>";
  const char prompt_m801[] = "m801l(r)>";
  const char prompt_m802[] = "m802l(r)>";
#endif
  const char *prompt;

/* prototype */
//static void dhcp_client(void);						/* DHCP Client */
/*-----*/
static void disp_title(void);						/* ^Cg\ */
//static void disp_laninfo(void);						/* Ethernet֘A\ */
/*-----*/
//static int con_job(word *data, PARAM_INFO *param);	/* R\[ */
static void http_server(void);						/* HTTP Server */
/*-----*/
static void ad_job(void);
/*-----*/
static int judge_cpu(void);
/*-----*/
static bool cmd_load(const PARAM_INFO *param);
static bool cmd_go(const PARAM_INFO *param);
static bool cmd_dump(const PARAM_INFO *param);
static bool cmd_fill(const PARAM_INFO *param);
static bool cmd_test(const PARAM_INFO *param);
static bool cmd_help(const PARAM_INFO *param);
static bool cmd_ver(const PARAM_INFO *param);
static bool cmd_reset(const PARAM_INFO *param);
static bool cmd_dhcp(const PARAM_INFO *param);
static bool cmd_usb(const PARAM_INFO *param);

static bool usb_start;

/*-------------------------------------------------------------------
/ obNAbvf[^NA
/	DOC:
/	  BACKUPZNV
/------------------------------------------------------------------*/
void clear_backupdata(void)
{
	char *p, *q;
	for(p = (char *)__sectop("BBACKUP"); p < (char *)__secend("BBACKUP"); p++){
		*p = 0;
	}
}

/*-------------------------------------------------------------------
/ EFCgimsecj
/------------------------------------------------------------------*/
void waitms(int ms)
{
	long time;
	time = tim1ms;
	while(tim1ms - time <= ms){;}
}

/*-------------------------------------------------------------------
/ MAIN
/------------------------------------------------------------------*/
void main_m801(void)
{
	BSC.BCR.BIT.WAITE = 1;				/* /WAITgp */
	NicInit(waitms);

	while(1){
		tcpudp_input( );	/* TCP/IP̓^XN */
		cmd_job();
		ad_job();
		if( EtherGetIP() != 0 ){
			http_server();
		}
	}
}

void main_m802(void)
{
//	#define BUFSIZE	16
//	#define BUFSIZE	20
	#define BUFSIZE	42
	int len;
	static byte buff[BUFSIZE];

	BSC.ASTCR.BIT.AST2 = 0;		/* 2state(USBN9604) */

	while(1){
		cmd_job();
		if( usb_start ){
			/* loop back */
			if( (len = UsbGet(1, buff, BUFSIZE)) > 0 ){
				UsbPut(1, buff, len);
			}
		}
	}
}

void main(void)
{
	/*--- CPU{[h̔ ---*/
	cpu_type = judge_cpu();
	switch( cpu_type ){
		case CPU_M800: prompt = prompt_m800;	break;
		case CPU_M801: prompt = prompt_m801;	break;
		case CPU_M802: prompt = prompt_m802;	break;
	}
	/*--- R}hGg ---*/
	cmd_prompt(prompt);
	cmd_entry("Load",	1, cmd_load);
	cmd_entry("Go",		1, cmd_go);
	cmd_entry("Dump",	1, cmd_dump);
	cmd_entry("Fill",	1, cmd_fill);
	cmd_entry("Test",	1, cmd_test);
	cmd_entry("Reset",	1, cmd_reset);
	if( cpu_type == CPU_M801 ){
		cmd_entry("Ip",		1, cmd_dhcp);
	}
	if( cpu_type == CPU_M802 ){
		cmd_entry("Usb",	1, cmd_usb);
	}
	cmd_entry("Ver",	1, cmd_ver);
	cmd_entry("?",		1, cmd_help);
	cmd_entry("Help",	1, cmd_help);

	sci1_init();
	ad_init();
	if( cpu_type == CPU_M801 ){
		tcp_init(&tim1ms);
		udp_init();
	}

	disp_title();

	if( cpu_type == CPU_M801 ){
		main_m801();
	}else if( cpu_type == CPU_M802 ){
		main_m802();
	}
	while(1){
		cmd_job();
	}
}

/*-------------------------------------------------------------------
/ abort
/------------------------------------------------------------------*/
void abort(void)
{
}

/*---------------------------------------------------------
/ DHCP CLIENT
/--------------------------------------------------------*/
void dhcp_client(void)
{
	dword ip;
	dword netmask, gateway;
	debug_out("Run DHCP CLIENT\r\n");
	debug_out("wait...\r");
	waitms(3000);

	dhcp_discover( );
	do{
		tcpudp_input( );
	}while( !dhcp_input(&ip, &netmask, &gateway) );
	dhcp_close();
	debug_out("       \r");
	EtherSetIP(ip);
	EtherSetNetmask(netmask);
	EtherSetGateway(gateway);
}

/*---------------------------------------------------------
/ ^Cg\
/--------------------------------------------------------*/
static void disp_title(void)
{
#if defined(RAM_EMULATE)
	waitms(3000);
#endif
	debug_out("\r\n--- ");
	debug_out(cpu);
	debug_out(" V");
	debug_out(m801l_version);
	debug_out(" ");
	debug_out(" ---\r\n\r\n");
#if defined(RAM_EMULATE)
	debug_out("ram emulate\r\n\r\n");
#endif
}

/*---------------------------------------------------------
/ Ethernet֘A\
/--------------------------------------------------------*/
#if 1
void disp_laninfo(void)
{
	byte *macp;
	macp = NicGetMacAddress();
	debug_outb3("MAC ",	*macp++, "-");
	debug_outb3("",		*macp++, "-");
	debug_outb3("",		*macp++, "-");
	debug_outb3("",		*macp++, "-");
	debug_outb3("",		*macp++, "-");
	debug_outb3("",		*macp,	 "\r\n");
	debug_out("IP  ");
	debug_out(inet_ntoa(EtherGetIP(), (char*)tmp));			debug_out("\r\n");
	debug_out("netmask ");
	debug_out(inet_ntoa(EtherGetNetmask(), (char*)tmp));	debug_out("\r\n");
	debug_out("gateway ");
	debug_out(inet_ntoa(EtherGetGateway(), (char*)tmp));	debug_out("\r\n");
	debug_out("\r\n");
}
#endif
/*-----------------------------------------------------------------*/
/*---------------------------------------------------------
/ HTTP SERVER(tcp)
/--------------------------------------------------------*/
#if 1
static void http_server(void)
{
	enum{
		CONNECT,			/* ڑ҂ */
		ESTAB,				/* f[^] */
		WCLOSE				/* ڑ~҂ */
	};
//	#define CONNECT_MAX		4
	#define CONNECT_MAX		2
	static byte hbuf[1024];
	static int src = -1;
	static int dst[CONNECT_MAX];
	static int job[CONNECT_MAX];
	static bool first = TRUE;
	int i;

	/*  */
	if( first ){
		first = FALSE;
		if( (src = tcp_socket()) < 0 ){
			debug_out("error tcp_scoket() in http_server()\r\n");
		}else{
			tcp_bind(src, 80);
			if( tcp_listen(src, CONNECT_MAX) != CONNECT_MAX ){
				debug_out("error tcp_listen() in http_server()\r\n");
			}
		}
	}else{
		int len;
		for( i = 0; i < CONNECT_MAX; i++ ){
			if( job[i] == CONNECT ){
				if( (dst[i] = tcp_accept(src)) >= 0 ){
					job[i] = ESTAB;
				}
			}
			if( job[i] == ESTAB ){
				len = tcp_recv(dst[i], (byte*)hbuf, 1024);
				if( len > 0 ){
					hbuf[len] = '\0';
					http_output(dst[i], hbuf);
					job[i] = WCLOSE;
				}else{
					if( tcp_status(dst[i]) != ESTABLISHED ){	/* Reset */
						job[i] = WCLOSE;
					}
				}
			}else if( job[i] == WCLOSE ){
				if( tcp_recv(dst[i], (byte*)hbuf, 512) == 0 ){
					tcp_closesocket(dst[i]);
					job[i] = CONNECT;
				}
			}
		}
	}
}
#endif
/*---------------------------------------------------------
/ AD
/--------------------------------------------------------*/
static void ad_job(void)
{
	word ad;
	if( (ad = ad_getdata()) & 0x8000 ){
		ad_data = ad & ~0x8000;			/* update */
	}
}

/*---------------------------------------------------------
/ CPU{[h									ADD 001
/--------------------------------------------------------*/
static void nop(void)
{
}
static int judge_cpu(void)
{
	#define UNKNOWN_CS2	0x400000

	#define RTL_8019ID0	(*((volatile byte *)(UNKNOWN_CS2+(0x0a * 2))))	/* RO:Page0 */
	#define RTL_8019ID1	(*((volatile byte *)(UNKNOWN_CS2+(0x0b * 2))))	/* RO:Page0 */

	#define USBN9604_ADDR	(*(volatile byte *)(UNKNOWN_CS2+0x02))
	#define USBN9604_DATA	(*(volatile byte *)(UNKNOWN_CS2+0x00))
	#define RID				0x03
	#define DMA_CTRL		0x14
	/*---- check exist RTL8019A ---*/
	if( RTL_8019ID0 == 'P' && RTL_8019ID1 == 'p' ){
		return CPU_M801;
	}
	/*---- check exist USBN9604 ---*/
	{
		byte rdt1,rdt2;
		/* read RID */
		USBN9604_ADDR = RID;
		nop();
		rdt1 = USBN9604_DATA & 0x0f;
		/* write/read DMA CTRL */
		USBN9604_ADDR = DMA_CTRL;
		nop();
		USBN9604_DATA = 0x7f;
		nop();
		rdt2 = USBN9604_DATA;
		if( rdt1 == 0x02 && rdt2 == 0x7f ){
			return CPU_M802;
		}
	}
	return CPU_M800;
}

/*-------------------------------------------------------------------
/ R}hʃp[^́Zbgs				ADD 001
/------------------------------------------------------------------*/
const char delim[] = "\r\n";

#define msg_addr(w)						\
			dword2str((w), (char*)tmp);	\
			debug_out((char*)tmp)

#define msg_data(b)						\
			byte2str((b), (char*)tmp);	\
			debug_out((char*)tmp)


#define user_break()	(sci1_get() == (0x100 | 0x1b))		/* ESC */

#define MEM_BASE		0x200000
#define MEM_SIZE		0x40000

/* Load <addr> <size> */
static bool cmd_load(const PARAM_INFO *param)
{
	static const char help[] = " Load <addr> <size> [S]\r\n";
	long time;
	dword addr, size, i;
	word data;
	bool silence = FALSE;

	if( param->count < 2 ){
		debug_out(help);
		return TRUE;
	}

	addr = str2hex(param->p[0]);
	size = str2dec(param->p[1]);
	if( toupper(*(param->p[2])) == 'S' ){
		silence = TRUE;
	}

	if( !silence ){
		debug_out(" Load ");
		msg_addr(addr);
		debug_out(" - ");
		msg_addr(addr+size-1);
		debug_out(delim);
	}

	time = tim1ms;
	for(i = 0; i < size; i++, addr++){
//		PBDR.BIT.B0 = 1;							//DEBUG
		time = tim1ms;
		while( !((data = sci1_get()) & 0x100) ){
			if(tim1ms - time > 5000){
				debug_out("\r\ntime out!");
				goto END;
			}
		}
		*(volatile byte *)addr = (byte)data;
		if( !silence && (i % 100) == 0 ){
			sci1_put('.');
			sci1_txtrg();
		}
//		PBDR.BIT.B0 = 0;							//DEBUG
	}
	debug_out("\r\nend!");
END:
	debug_out(delim);
	return TRUE;
}
/* Go <addr> */
static bool cmd_go(const PARAM_INFO *param)
{
	static const char help[] = " Go <addr>\r\n";
	uprg user_program;
	long time;

	if( param->count != 1 ){
		debug_out(help);
		return TRUE;
	}

	user_program_addr = str2hex(param->p[0]);
	user_program = (uprg)(*(dword *)(user_program_addr + 0x00));

	debug_out("addr=");
	msg_addr((dword)user_program);
	debug_out(delim);

//	PBDR.BIT.B0 = 1;							//DEBUG
	time = tim1ms;
	while(tim1ms - time < 100){;}
//	PBDR.BIT.B0 = 0;							//DEBUG
	InitCpuRegister();				/* WX^ */
	user_program_flag = TRUE;
	PBDDR = 0xff;
//	PBDR.BIT.B0 = 1;							//DEBUG
	user_program();
	return TRUE;
}
/* Dump <addr> <size> */
static bool cmd_dump(const PARAM_INFO *param)
{
	static const char help[] = " Dump <addr> <size>\r\n";
	dword addr, size, i;
	dword remain;

	if( param->count != 2 ){
		debug_out(help);
		return TRUE;
	}

	addr = str2hex(param->p[0]);
	size = str2dec(param->p[1]);

	debug_out(" Dump ");
	msg_addr(addr);
	debug_out(" - ");
	msg_addr(addr+size-1);
	debug_out(delim);

	if( (remain = addr % 16) != 0 ){
		debug_out(delim);
		msg_addr(addr & ~0xf);
		debug_out("  ");
		for(i = 0; i < remain; i++){
			debug_out("   ");
		}
		remain = 16 - remain;
		for(i = 0; i < remain; i++, addr++){
			msg_data(*(volatile byte *)addr);
			debug_out(" ");
		}
		size -= remain;
	}

	for(i = 0; i < size; i++, addr++){
		if( (addr % 16) == 0 ){
			if( sci1_get() == (0x100 | '\b') ){ break; }
			debug_out(delim);
			msg_addr(addr);
			debug_out("  ");
		}
		msg_data(*(volatile byte *)addr);
		debug_out(" ");
	}
	debug_out(delim);
	debug_out(delim);
	return TRUE;
}
/* Fill <addr> <size> <data> */
static bool cmd_fill(const PARAM_INFO *param)
{
	static const char help[] = " Fill <addr> <size> <data>\r\n";
	dword addr, size, i;
	byte data;

	if( param->count != 3 ){
		debug_out(help);
		return TRUE;
	}

	addr = str2hex(param->p[0]);
	size = str2dec(param->p[1]);
	data = (byte)str2hex(param->p[2]);

	debug_out(" Fill ");
	msg_addr(addr);
	debug_out(" - ");
	msg_addr(addr+size-1);
	debug_out(" ");
	msg_data(data);
	debug_out(delim);

	for(i = 0; i < size; i++, addr++){
		*(volatile byte *)addr = data;
		if((i % 100) == 0){
			sci1_put('.');
			sci1_txtrg();
		}
	}
	debug_out(delim);
	debug_out(delim);
	return TRUE;
}
/* Test <num> */
#define ADDR_TBL_MAX	37

const dword addr_tbl[ADDR_TBL_MAX] = {
	0x00000, 
			 /* 0001     0011     0010     0110     0100     1100     1000 */
			 0x00001, 0x00003, 0x00002, 0x00006, 0x00004, 0x0000C, 0x00008,
	0x00018, 0x00010, 0x00030, 0x00020, 0x00060, 0x00040, 0x0000C, 0x00080,
	0x00180, 0x00100, 0x00300, 0x00200, 0x00600, 0x00400, 0x0000C, 0x00800,
	0x01800, 0x01000, 0x03000, 0x02000, 0x06000, 0x04000, 0x0000C, 0x08000,
	0x18000, 0x10000, 0x30000, 0x20000,
	0x3FFFF
};
#define DATA_TBL_MAX	17
const byte data_tbl[DATA_TBL_MAX] = {
		  0x01, 0x03, 0x02, 0x06, 0x04, 0x0c, 0x08,
	0x18, 0x10, 0x30, 0x20, 0x60, 0x40, 0xc0, 0x80,
	0x55, 0xaa
};

#define MEMCHK_ERROR_MAX	25

/* ret: -1:user break, 0>= : error count */
static int mem_chk_full(byte fill)
{
	int ec = 0;
	dword i;
	byte data;

	/* fill */
	for(i = 0; i < MEM_SIZE; i++){
		if( user_break() ){
			debug_out("\r\nbreak!\r\n");
			return -1;
		}
		*(volatile byte *)(MEM_BASE + i) = fill;
	}
	/* check */
	for(i = 0; i < MEM_SIZE; i++){
		if( user_break() ){
			debug_out("\r\nbreak!\r\n");
			return -1;
		}
		if((data = *(volatile byte *)(MEM_BASE + i)) != fill){
			debug_out("\r\nerror ");
			debug_out("addr=");
			msg_addr(MEM_BASE + i);
			debug_out(" data=");
			msg_data(data);
			if(++ec > MEMCHK_ERROR_MAX){
				debug_out("\r\ntoo many errors\r\n");
				return ec;
			}
		}
	}
	if( ec == 0 ){ debug_out("pass\r\n"); }

	return ec;
}


static void test1(void)
{
	int ec, acc, bcnt;
	dword i, j;
	byte data, cdt;

	debug_out("\r\n*Memory check\r\n");
	debug_out("ALL FFh -> ");
	ec = mem_chk_full(0xff);
	if( ec == -1 || ec > MEMCHK_ERROR_MAX ){ return; }
	acc = ec;
	debug_out("ALL 00h -> ");
	ec = mem_chk_full(0x00);
	acc += ec;
	if( ec == -1 || acc > MEMCHK_ERROR_MAX ){ return; }

	bcnt = 0;
	for(i = 0; i < ADDR_TBL_MAX; i++){
		cdt = data_tbl[bcnt];
		msg_addr(MEM_BASE + addr_tbl[i]);
		debug_out(" ");
		msg_data(data_tbl[bcnt]);
		debug_out("h -> ");
		*(volatile byte *)(MEM_BASE + addr_tbl[i]) = cdt;	/* set */
		ec = 0;
		for(j = 0; j < MEM_SIZE; j++){
			if( user_break() ){
				debug_out("\r\nbreak!\r\n");
				return;
			}
			if( j == addr_tbl[i] ){
				if( (data = *(volatile byte *)(MEM_BASE + j)) != cdt ){
					goto MEM_ERROR;
				}
			}else{
				if( (data = *(volatile byte *)(MEM_BASE + j)) != 0x00){
MEM_ERROR:
					debug_out("\r\nerror ");
					debug_out("addr=");
					msg_addr(MEM_BASE + j);
					debug_out(" data=");
					msg_data(data);
					if( ++ec > MEMCHK_ERROR_MAX ){
						debug_out("\r\ntoo many errors\r\n");
						return;
					}
				}
			}
		}

		*(volatile byte *)(MEM_BASE + addr_tbl[i]) = 0x00;	/* clear */

		if( ++bcnt == DATA_TBL_MAX){ bcnt = 0; }
		acc += ec;
		if( acc > MEMCHK_ERROR_MAX ){
			debug_out("too many errors\r\n");
			return;
		}
		if( ec == 0 ){
			debug_out("pass\r\n");
		}else{
			debug_out(delim);
		}
	}
}

static bool cmd_test(const PARAM_INFO *param)
{
	static const char help[] = " Test <number>\r\n"
						"  number = 1 : memory check\r\n";
	int number;

	if( param->count != 1 ){
		debug_out(help);
		return TRUE;
	}

	number = (int)str2dec(param->p[0]);
	if( number == 1 ){
		test1();
	}else if( number == 2 ){
		test_loopback();
	}else{
		debug_out("\r\n");
	}
	return TRUE;
}
/* Help */
/* ?    */
static bool cmd_help(const PARAM_INFO *param)
{
	static const char help[] = 
		"\r\n"
		" Load <addr> <size> [S]\r\n"
		" Go   <addr>\r\n"
		" Dump <addr> <size>\r\n"
		" Fill <addr> <size> <data>\r\n"
		"  <addr> = address(hex)\r\n"
		"  <size> = data size(dec)\r\n"
		"  <data> = data value(hex)\r\n"
		"  <num> = number(dec)\r\n\r\n"
		" Test <num>\r\n"
		"   num=1:memory test\r\n"
		" Reset\r\n"
		" Ip [<ip> <netmask> <gateway>] (M-801 only)\r\n"
		" Usb S <vid> <pid> (M-802 only)\r\n"
		"   vid=vendor ID(hex)\r\n"
		"   pid=product ID(hex)\r\n"
		" Usb E\r\n"
		" Ver\r\n"
		" ? or Help\r\n\r\n";
	debug_out(help);
	return TRUE;
}

/* Ver */
static bool cmd_ver(const PARAM_INFO *param)
{
	debug_out("M800L V");
	debug_out(m801l_version);
	debug_out("\r\n\r\n");
	return TRUE;
}

/* Reset */
static bool cmd_reset(const PARAM_INFO *param)
{
	debug_out("\r\nClear backup data\r\n");
	clear_backupdata();
	debug_out("\r\n");
	return TRUE;
}

/* Ip [<ip> <netmask> <gateway> */
static bool cmd_dhcp(const PARAM_INFO *param)
{
	static const char help[] = " Ip [<ip> <netmask> <gateway>]\r\n";

	if( param->count != 0 && param->count != 3 ){
		debug_out(help);
		return TRUE;
	}
	if( param->count == 0 ){		/* DHCP ClientɂIP擾 */
		dhcp_client();
	}
	else if( param->count == 3 ){	/* 蓮ݒ */
		dword ip, nmask, gway;
		ip = inet_addr(param->p[0]);
		nmask = inet_addr(param->p[1]);
		gway = inet_addr(param->p[2]);
		EtherSetIP(ip);
		EtherSetNetmask(nmask);
		EtherSetGateway(gway);
	}
	disp_laninfo();
	return TRUE;
}

/* Usb S <cid> <pid> */
/* Usb E */
static bool cmd_usb(const PARAM_INFO *param)
{
	#define TX_BUFSIZE		128
	#define RX_BUFSIZE		128

	#define LOW(w)			((byte)w)
	#define HIGH(w)			((byte)(w >> 8))

	#define EP_OUT	0x00	/* OUT */
	#define EP_IN	0x80	/* IN */

	#define EP_CTRL	0x00	/*  */
	#define EP_ISO	0x01	/* AC\NiX */
	#define EP_BULK	0x02	/* oN */
	#define EP_INTR	0x03	/* 荞 */
	static const char help[] = " Usb\r\n"
						" Usb S <cid> <pid>\r\n"
						" Usb E\r\n\r\n";
	static byte dev_desc[] = {
		0x12, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x08,
		0xff,0xff,
		0x01,0x00,
		0x01,0x00, 0x00, 0x00, 0x00, 0x01
	};

	static const byte cfg_desc[] = {
		0x09, 0x02, 9+9+7*3, 0x00, 0x01, 0x01, 0x00, 0xc0, 100,	/* configuration */
		0x09, 0x04, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x03,	/* interface */
		7,	5,	EP_IN + 1,	EP_BULK, LOW(64), HIGH(64),	255,	/* endpoint(pipe 0) */
		7,	5,	EP_OUT + 2,	EP_BULK, LOW(64), HIGH(64),	255		/* endpoint(pipe 1) */
	};
	static const byte lang_data[] = {
		4,3,	9,4			/* LANGID (English) */
	};
	static const byte mfg_str[] = {
		14, 3,	'M',0,'8',0,'0',0,'2',0,'P',0,'1',0
	};
	static const byte nbr_str[] = {
		8,3,	'0',0,'.',0,'1',0
	};
	static const byte int_str[] = {
		34,3,
		'U',0,'S',0,'B',0,' ',0,
		'T',0,'E',0,'S',0,'T',0,' ',0,'P',0,'R',0,'O',0,'G',0,'R',0,'A',0,'M',0,
	};
	static const SETTING_INFO setting = {
		FALSE,				/* NXNGXgFȂ */
		NULL,				/* |[gfBXNv^F */
		FALSE,				/* SET INTERFACET|[gFȂ */
		FALSE
	};
	static DESCRIPTOR_INFO desc;
	static USBBUF_INFO uinfo;
	static ENDPOINT_INFO einfo;
	static byte tx[TX_BUFSIZE];
	static byte rx[RX_BUFSIZE];

	/*--- END ---*/
	if( param->count == 1 && toupper(*(param->p[0])) == 'E' ){
		debug_out("USB END\r\n\r\n");
		INTC.IER.BIT.IRQ5E = 0;				// 荞݋֎~
		UsbReset();
		usb_start = FALSE;
	}
	else
	/*--- START ---*/
	if( param->count == 3 && toupper(*(param->p[0])) == 'S' ){
		word vid, pid;
		vid = str2hex(param->p[1]);
		pid = str2hex(param->p[2]);
		dev_desc[ 8] = (byte)vid;	dev_desc[ 9] = (byte)(vid >> 8);
		dev_desc[10] = (byte)pid;	dev_desc[11] = (byte)(pid >> 8);

		debug_out("USB START\r\n\r\n");

		desc.device = dev_desc;
		desc.config = cfg_desc;
		desc.langage = lang_data;
		desc.mfg_str = mfg_str;
		desc.nbr_str = nbr_str;
		desc.int_str = int_str;
		UsbSetAction(&desc, &setting);
		/*---*/
		uinfo.no = 1;
		uinfo.tmp = tx;
		uinfo.size = TX_BUFSIZE;
		uinfo.addition = TRUE;
		einfo.epc = 1;
		einfo.addr = 1;
		einfo.iso = FALSE;
		UsbSetWriteBuf(&uinfo, &einfo);
		uinfo.no = 1;
		uinfo.tmp = rx;
		uinfo.size = RX_BUFSIZE;
		uinfo.addition = TRUE;
		einfo.epc = 2;
		einfo.addr = 2;
		einfo.iso = FALSE;
		UsbSetReadBuf(&uinfo, &einfo);

		UsbInit();
		INTC.IER.BIT.IRQ5E = 1;				// 荞݋
		usb_start = TRUE;
	}
	else{
		debug_out(help);
	}
	return TRUE;
}
